config/routes.rb
Rails.application.routes.draw do
  root 'monsters#index'

  get '/testing',    to: 'monsters#testing',          as: :testing
  get '/training',   to: 'monsters#training_process', as: :training
end

app/models/monster.rb
# == Schema Information
#
# Table name: monsters
#
#  id      :integer          not null, primary key
#  name    :string(255)
#  level   :integer
#  hp      :integer
#  exp     :integer
#  jexp    :integer
#  atk     :integer
#  def     :integer
#  mdef    :integer
#  str     :integer
#  agi     :integer
#  vit     :integer
#  int     :integer
#  dex     :integer
#  luk     :integer
#  scale   :integer
#  race    :integer
#  element :integer
#

# Monster model
class Monster < ActiveRecord::Base
  def self.in_range(hero_level)
    where('level between ? and ?', hero_level - 20, hero_level + 20)
  end
end

app/models/user.rb
# == Schema Information
#
# Table name: users
#
#  id         :integer          not null, primary key
#  username   :string(255)
#  gold       :integer          default(0)
#  level      :integer          default(1)
#  hp         :integer          default(1000)
#  exp        :integer          default(0)
#  atk        :integer          default(25)
#  created_at :datetime         not null
#  updated_at :datetime         not null
#

class User < ActiveRecord::Base
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception
end

app/controllers/monsters_controller.rb
# Monsters controller
class MonstersController < ApplicationController
  require 'ruby_fann/neurotica'

  # Main output
  def index
    @user     = User.last
    @monsters = Monster.in_range(@user.level)
  end

  def testing
    neural_network =
      RubyFann::Standard.new(filename: 'public/neural_network.net')
    render plain: neural_network.run([1000, 25, 50, 7])
  end

  # Training process
  def training_process
    train_on_data(neural_network, training_data)
    redirect_to root_path, flash: { result: 'Training complete' }
  end

  private

  # Create training data for teaching neural network
  def training_data
    data # => [[1000, 25, 50, 7], [1000, 25, 169, 22],...]
    training_data = RubyFann::TrainData.new(
      inputs: @data,
      desired_outputs: desired_outputs(@data)
    )
    training_data.save('public/verify.train')
  end

  # Prepare data via fight calculation
  def data
    main_characters
    @data = []
    # Fight part
    @monsters.each do |monster|
      # pair = []
      # pair <<
      @data << [@hero.hp, @hero.atk, monster.hp, monster.atk]
    end
    @data
    # raise main_characters.inspect
  end

  # Prepare hero and monsters data
  def main_characters
    @hero     = User.last
    # @monsters = Monster.in_range(@hero.level)
    @monsters = Monster.all
  end

  # Desired outputs using pairs of hero and monster fight results
  def desired_outputs(pairs)
    @desired_output = []
    pairs.each do |pair|
      hero_hp     = pair[0]
      hero_atk    = pair[1]
      monster_hp  = pair[2]
      monster_atk = pair[3]

      # Init fight
      fight(hero_hp, hero_atk, monster_hp, monster_atk)
    end
    @desired_output
  end

  def fight(hero_hp, hero_atk, monster_hp, monster_atk)
    while hero_hp >= 0 && monster_hp >= 0
      monster_hp -= hero_atk
      hero_hp    -= monster_atk
    end

    @desired_output << if hero_hp >= 0 && monster_hp <= 0
                         [1]
                       else
                         [0]
                       end
  end

  # Learning
  def train_on_data(network, training_data)
    network.train_on_data(
      training_data,
      1_000_000, # count of epochs
      1000,   # number of periods after which output the result
      0.01    # desired MSE (mean-squared-error)
    )

    # Save neural network
    network.save('public/neural_network.net')

    # Graph
    graph = RubyFann::Neurotica.new
    graph.graph(neural_network, 'public/fight.png')
  end

  # Init neural network
  def neural_network
    RubyFann::Standard.new(
      filename: 'public/neural_network.net',
      num_inputs: 4,
      hidden_neurons: [5, 3, 1, 3, 5],
      num_outputs: 1
    )
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/monsters_helper.rb
# == Schema Information
#
# Table name: monsters
#
#  id      :integer          not null, primary key
#  name    :string(255)
#  level   :integer
#  hp      :integer
#  exp     :integer
#  jexp    :integer
#  atk     :integer
#  def     :integer
#  mdef    :integer
#  str     :integer
#  agi     :integer
#  vit     :integer
#  int     :integer
#  dex     :integer
#  luk     :integer
#  scale   :integer
#  race    :integer
#  element :integer
#

# Monsters helper
module MonstersHelper
  def fight_result?(hero, monster)
    neural_network =
      RubyFann::Standard.new(filename: 'public/neural_network.net')
    if neural_network.run(
      [hero.hp, hero.atk, monster.hp, monster.atk]
    ).first.to_f > 0.5
      'Fight'
    else
      'Runaway!'
    end
  end
end

app/views/layouts/application.slim
/ encoding: utf-8
doctype html
html
  head
    meta charset="utf-8"
      meta http-equiv="X-UA-Compatible" content="IE=Edge,chrome=1"
      meta name="viewport" content="width=device-width, initial-scale=1.0"
      title
        = page_title(app_name: 'Neural networks', separator: ' | ')
      = csrf_meta_tags
      link href="//fonts.googleapis.com/css?family=Lato:300,400%7CRaleway:100,400,300,500,600,700%7COpen+Sans:400,500,600" rel="stylesheet" type="text/css"
      link href="//fonts.googleapis.com/css?family=Dosis:100,300,400,600,700" rel="stylesheet" type="text/css"
      link href="//maxcdn.bootstrapcdn.com/font-awesome/4.5.0/css/font-awesome.min.css" rel="stylesheet" type="text/css"
      = stylesheet_link_tag "application", :media => "all"
      = favicon_link_tag '/favicon.ico', :rel => 'shortcut icon'
      = javascript_include_tag "application"

    body.nav-is-overlay
      div.main-container
        = render './partials/header'
        = yield
        / = render './partials/footer'

app/views/monsters/index.slim
div.row.text-center
  br
  div.col-md-6.col-md-offset-3
    - flash.each do |name, msg|
      = content_tag :div, msg, class: "alert alert-info"
  br
  div.col-md-6.col-md-offset-3
    = link_to 'Training', training_path, class: 'btn btn-inverse btn-block'
  div.col-md-6.col-md-offset-3
    h1.text-center
      | Monsters
    table.table.table-striped.table-hover
      thead
        tr
          th
            | Level
          th
            | Name
          th
            | HP
          th
            | Result
      tbody
        - @monsters.each do |monster|
          tr
            td
              = monster.level
            td
              = monster.name
            td
              = monster.hp
            td
              = fight_result?(@user, monster)

app/views/partials/_header.slim
div.nav-container.bg-light style="min-height: 55px;"
  
  / Якорь для ссылки "Наверх"
  a#top
  
  / Верхнее меню
  nav.bg-light
    div.nav-bar
      div.module.left
        = link_to root_path do
          p.mb0.uppercase.lead
            | Neural networks
      div.module.widget-handle.mobile-toggle.right.visible-sm.visible-xs
        i.ti-menu
      div.module-group.right
        div.module.left
          ul.menu
            li
              = link_to 'Testing', testing_path, class: 'inner-link'